<template>
  <div>
    <q-select
      v-model="field.config.collection"
      stack-label="Collection"
      inverted-light
      color="white"
      :options="availableCollections"
      :filter="availableCollections.length > 10"
      :disable="isLoadingCollections"
    />
    <q-select
      v-model="field.config.keyField"
      stack-label="Key field"
      inverted-light
      color="white"
      :options="availableFields"
      :filter="availableFields.length > 10"
      :disable="!field.config.collection || isLoadingFields"
      class="q-mt-md"
    />
    <q-select
      v-model="field.config.labelField"
      stack-label="Label field"
      inverted-light
      color="white"
      :options="availableFields"
      :filter="availableFields.length > 10"
      :disable="!field.config.collection || isLoadingFields"
      class="q-mt-md"
    />
    <q-checkbox
      v-model="field.config.isMultiple"
      label="Is Multiple"
      class="q-mt-md"
    />
    <q-select
      v-model="field.config.fieldType"
      stack-label="Field type"
      inverted-light
      color="white"
      :options="availableFieldTypes"
      class="q-mt-md"
    />
  </div>
</template>

<script>
  import endpointsMixin from '../../../../../../../mixins/endpointsMixin';

  export default {
    name: 'collectionField',
    props: {
      field: {
        type: Object,
      },
    },
    mixins: [endpointsMixin],
    created() {
      this.loadCollections();
      if (this.field.config.collection) {
        this.loadCollectionConfig();
      }
    },
    data() {
      return {
        availableCollections: [],
        isLoadingCollections: false,

        collectionConfig: null,
        isLoadingCollectionConfig: false,

        availableFields: [],
        isLoadingFields: false,

        availableFieldTypes: ['dropdown', 'autocomplete'].map((value) => ({
          value,
          label: value,
        })),
      };
    },
    watch: {
      // eslint-disable-next-line func-names
      'field.config.collection': function (collection, oldCollection) {
        if (collection) {
          if (oldCollection) {
            this.field.config.keyField = null;
            this.field.config.labelField = null;
          }
          this.$nextTick(() => {
            this.loadCollectionConfig();
          });
        }
      },
    },
    methods: {
      loadFields() {
        this.isLoadingFields = true;

        this.fetchEndpointFields(this.collectionConfig.endpoint)
          .then((res) => {
            this.availableFields = Object.keys(res[0]).map((value) => ({
              value,
              label: value,
            }));
            this.isLoadingFields = false;
          });
      },
      loadCollectionConfig() {
        this.isLoadingCollectionConfig = true;

        this.fetchCollection(this.field.config.collection)
          .then((res) => {
            this.collectionConfig = res;
            this.isLoadingCollectionConfig = false;

            this.$nextTick(() => {
              this.loadFields();
            });
          });
      },
      loadCollections() {
        this.isLoadingCollections = true;
        this.fetchCollections()
          .then((results) => {
            this.isLoadingCollections = false;
            this.availableCollections = results.map(({ collection_id: value }) => ({
              value,
              label: value,
            }));
          });
      },
    },
  };
</script>
